File: ax_bam.m4

package info (click to toggle)
cufflinks 1.3.0-2
  • links: PTS, VCS
  • area: non-free
  • in suites: wheezy
  • size: 3,864 kB
  • sloc: cpp: 48,999; ansic: 12,297; sh: 3,381; python: 432; makefile: 209
file content (203 lines) | stat: -rw-r--r-- 6,650 bytes parent folder | download | duplicates (5)
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
# SYNOPSIS
#
#   AX_BAM
#
# DESCRIPTION
#
#   Test for the BAM libraries of a particular version (or newer)
#
#   If no path to the installed bam library is given the macro searchs
#   under /usr, /usr/local, /opt and /opt/local and evaluates the
#   $BAM_ROOT environment variable. 
#	Adapted from AX_BOOST_BASE
#
#   This macro calls:
#
#     AC_SUBST(BAM_CPPFLAGS) / AC_SUBST(BAM_LDFLAGS)
#
#   And sets:
#
#     HAVE_BAM
#
# LICENSE
#
#   Copyright (c) 2010 Cole Trapnell <cole@cs.umd.edu>
#
#   Copying and distribution of this file, with or without modification, are
#   permitted in any medium without royalty provided the copyright notice
#   and this notice are preserved.

AC_DEFUN([AX_BAM],
[
AC_ARG_WITH([bam],
	AS_HELP_STRING([--with-bam@<:@=DIR@:>@], [use BAM libraries (default is yes) - it is possible to specify the root directory for BAM (optional)]),
	[
    if test "$withval" = "no"; then
		want_bam="no"
    elif test "$withval" = "yes"; then
        want_bam="yes"
        ac_bam_path=""
    else
	    want_bam="yes"
        ac_bam_path="$withval"
	fi
    ],
    [want_bam="yes"])


AC_ARG_WITH([bam-libdir],
        AS_HELP_STRING([--with-bam-libdir=LIB_DIR],
        [Force given directory for bam libraries. Note that this will overwrite library path detection, so use this parameter only if default library detection fails and you know exactly where your bam libraries are located.]),
        [
        if test -d $withval
        then
                ac_bam_lib_path="$withval"
        else
                AC_MSG_ERROR(--with-bam-libdir expected directory name)
        fi
        ],
        [ac_bam_lib_path=""]
)

if test "x$want_bam" = "xyes"; then
#	bam_lib_version_req=ifelse([$1], ,1.20.0,$1)
#	bam_lib_version_req_shorten=`expr $bam_lib_version_req : '\([[0-9]]*\.[[0-9]]*\)'`
#	bam_lib_version_req_major=`expr $bam_lib_version_req : '\([[0-9]]*\)'`
#	bam_lib_version_req_minor=`expr $bam_lib_version_req : '[[0-9]]*\.\([[0-9]]*\)'`
#	bam_lib_version_req_sub_minor=`expr $bam_lib_version_req : '[[0-9]]*\.[[0-9]]*\.\([[0-9]]*\)'`
#	if test "x$bam_lib_version_req_sub_minor" = "x" ; then
#		bam_lib_version_req_sub_minor="0"
#    	fi
#	WANT_BAM_VERSION=`expr $bam_lib_version_req_major \* 100000 \+  $bam_lib_version_req_minor \* 100 \+ $bam_lib_version_req_sub_minor`
	AC_MSG_CHECKING(for bamlib)
	succeeded=no

	dnl first we check the system location for bam libraries
	if test "$ac_bam_path" != ""; then
		BAM_LDFLAGS="-L$ac_bam_path/lib"
		BAM_CPPFLAGS="-I$ac_bam_path/include"
	else
		for ac_bam_path_tmp in /usr /usr/local /opt /opt/local ; do
			if test -d "$ac_bam_path_tmp/include/bam" && test -r "$ac_bam_path_tmp/include/bam"; then
				BAM_LDFLAGS="-L$ac_bam_path_tmp/lib"
				BAM_CPPFLAGS="-I$ac_bam_path_tmp/include"
				break;
			fi
		done
	fi

    dnl overwrite ld flags if we have required special directory with
    dnl --with-bam-libdir parameter
    if test "$ac_bam_lib_path" != ""; then
       BAM_LDFLAGS="-L$ac_bam_lib_path"
    fi

	CPPFLAGS_SAVED="$CPPFLAGS"
	CPPFLAGS="$CPPFLAGS $BAM_CPPFLAGS"
	export CPPFLAGS

	LDFLAGS_SAVED="$LDFLAGS"
	LDFLAGS="$LDFLAGS $BAM_LDFLAGS"
	export LDFLAGS

	AC_LANG_PUSH(C++)
     	AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
	@%:@include <samtools/bam.h>
	]], [[
	]])],[
        AC_MSG_RESULT(yes)
	succeeded=yes
	found_system=yes
       	],[
       	])
	AC_LANG_POP([C++])

	dnl if we found no bam with system layout we search for bam libraries
	dnl built and installed without the --layout=system option or for a staged(not installed) version
	if test "x$succeeded" != "xyes"; then
		_version=0
		if test "$ac_bam_path" != ""; then
			if test -d "$ac_bam_path" && test -r "$ac_bam_path"; then
				for i in `ls -d $ac_bam_path/include/bam-* 2>/dev/null`; do
					_version_tmp=`echo $i | sed "s#$ac_bam_path##" | sed 's/\/include\/bam-//' | sed 's/_/./'`
					V_CHECK=`expr $_version_tmp \> $_version`
					if test "$V_CHECK" = "1" ; then
						_version=$_version_tmp
					fi
					VERSION_UNDERSCORE=`echo $_version | sed 's/\./_/'`
					BAM_CPPFLAGS="-I$ac_bam_path/include/bam-$VERSION_UNDERSCORE"
				done
			fi
		else
			for ac_bam_path in /usr /usr/local /opt /opt/local ; do
				if test -d "$ac_bam_path" && test -r "$ac_bam_path"; then
					for i in `ls -d $ac_bam_path/include/bam-* 2>/dev/null`; do
						_version_tmp=`echo $i | sed "s#$ac_bam_path##" | sed 's/\/include\/bam-//' | sed 's/_/./'`
						V_CHECK=`expr $_version_tmp \> $_version`
						if test "$V_CHECK" = "1" ; then
							_version=$_version_tmp
	               					best_path=$ac_bam_path
						fi
					done
				fi
			done

			VERSION_UNDERSCORE=`echo $_version | sed 's/\./_/'`
			BAM_CPPFLAGS="-I$best_path/include/bam-$VERSION_UNDERSCORE"
            if test "$ac_bam_lib_path" = ""
            then
               BAM_LDFLAGS="-L$best_path/lib"
            fi

	    		if test "x$BAM_ROOT" != "x"; then
				if test -d "$BAM_ROOT" && test -r "$BAM_ROOT" && test -d "$BAM_ROOT/stage/lib" && test -r "$BAM_ROOT/stage/lib"; then
					version_dir=`expr //$BAM_ROOT : '.*/\(.*\)'`
					stage_version=`echo $version_dir | sed 's/bam_//' | sed 's/_/./g'`
			        	stage_version_shorten=`expr $stage_version : '\([[0-9]]*\.[[0-9]]*\)'`
					V_CHECK=`expr $stage_version_shorten \>\= $_version`
                    if test "$V_CHECK" = "1" -a "$ac_bam_lib_path" = "" ; then
						AC_MSG_NOTICE(We will use a staged bam library from $BAM_ROOT)
						BAM_CPPFLAGS="-I$BAM_ROOT"
						BAM_LDFLAGS="-L$BAM_ROOT/stage/lib"
					fi
				fi
	    		fi
		fi

		CPPFLAGS="$CPPFLAGS $BAM_CPPFLAGS"
		export CPPFLAGS
		LDFLAGS="$LDFLAGS $BAM_LDFLAGS"
		export LDFLAGS

		AC_LANG_PUSH(C++)
	     	AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
		@%:@include <bam/version.hpp>
		]], [[
		]])],[
        	AC_MSG_RESULT(yes)
		succeeded=yes
		found_system=yes
       		],[
	       	])
		AC_LANG_POP([C++])
	fi

	if test "$succeeded" != "yes" ; then
		if test "$_version" = "0" ; then
			AC_MSG_ERROR([[We could not detect the bam libraries (version $bam_lib_version_req_shorten or higher). If you have a staged bam library (still not installed) please specify \$BAM_ROOT in your environment and do not give a PATH to --with-bam option.  If you are sure you have bam installed, then check your version number looking in <bam/version.hpp>. See http://randspringer.de/bam for more documentation.]])
		else
			AC_MSG_NOTICE([Your bam libraries seem too old (version $_version).])
		fi
	else
		BAM_LIB="-lbam"
		AC_SUBST(BAM_CPPFLAGS)
		AC_SUBST(BAM_LDFLAGS)
		AC_SUBST(BAM_LIB)
		AC_DEFINE(HAVE_BAM,,[define if the BAM library is available])
	fi

        CPPFLAGS="$CPPFLAGS_SAVED"
       	LDFLAGS="$LDFLAGS_SAVED"
fi

])